#include <Arduino.h>
#include <nRF24L01.h>
#include <RF24.h>
#include "config.h"
#include "radio.h"

static RF24 rf24(PIN_NRF24_CE, PIN_NRF24_CSN); // 10, 8
static byte addresses[][6] = {NETWORK_ADDRESS_MASTER_SEND, NETWORK_ADDRESS_MASTER_RECEIVE};

void Radio::begin(void) {
  display->addLogMessage("Start RF24 radio");
  pinMode(PIN_NRF24_CSN, OUTPUT);
  pinMode(PIN_NRF24_CE, OUTPUT);
  return;
  rf24.begin();
  if (rf24.isChipConnected()) { display->addLogMessage("*** RF chip found"); }
  else { display->addLogMessage("*** ERROR: RF chip not found!"); }
  rf24.setChannel(1);
  rf24.setPALevel(RF24_PA_MAX);
  rf24.setDataRate(RF24_2MBPS);
  rf24.setAutoAck(0);
  //radio.setRetries(2,15); // Optionally, increase the delay between retries & # of retries
  rf24.setCRCLength(RF24_CRC_8);
  rf24.openWritingPipe(addresses[0]);
  rf24.openReadingPipe(1, addresses[1]);
  rf24.startListening();
  rf24.printDetails();
  // @TODO: real random seed!
  //randomSeed(analogRead(0));
  //randomSeed(22);
  rf24.powerUp();
  Serial.print("*** RF payload size="); Serial.print(rf24.getPayloadSize()); Serial.println(" bytes");
  if (rf24.testCarrier() || rf24.testRPD()) { display->addLogMessage("*** Carrier/RPD seen on radio"); }
  if (rf24.failureDetected) { display->addLogMessage("*** Radio error detected!"); }


#if 0
  // Open a writing and reading pipe on each radio, with opposite addresses
  if (isMaster){
    rf24.openWritingPipe(addresses[1]);
    rf24.openReadingPipe(1,addresses[0]);
  } else {
    rf24.openWritingPipe(addresses[0]);
    rf24.openReadingPipe(1,addresses[1]);
  }

#endif

  // Start the radio listening for data
  rf24.startListening();
}


void Radio::loop(void) {
  #if 0
  // put your main code here, to run repeatedly:
  /****************** Ping Out Role ***************************/
  if (isMaster)  {

      radio.stopListening();

      Serial.println(F("Now sending"));

      unsigned long start_time = micros();
       if (!radio.write(&start_time, sizeof(unsigned long))) {
         Serial.println(F("failed"));
       }

      radio.startListening();

      unsigned long started_waiting_at = micros();
      boolean timeout = false;

      while (!radio.available()) {
        if (micros() - started_waiting_at > 200000 ) {            // If waited longer than 200ms, indicate timeout and exit while loop
            timeout = true;
            break;
        }
      }

      if (timeout) {
          Serial.println(F("Failed, response timed out."));
      } else {
          unsigned long got_time;
          radio.read( &got_time, sizeof(unsigned long) );
          unsigned long end_time = micros();

          // Spew it
          Serial.print(F("Sent "));
          Serial.print(start_time);
          Serial.print(F(", Got response "));
          Serial.print(got_time);
          Serial.print(F(", Round-trip delay "));
          Serial.print(end_time-start_time);
          Serial.println(F(" microseconds"));
      }

      // Try again 1s later
      delay(1000);
    }



  /****************** Pong Back Role ***************************/

    if (!isMaster)
    {
      unsigned long got_time;

      if( radio.available()){
                                                                      // Variable for the received timestamp
        while (radio.available()) {                                   // While there is data ready
          radio.read( &got_time, sizeof(unsigned long) );             // Get the payload
        }

        radio.stopListening();                                        // First, stop listening so we can talk
        radio.write( &got_time, sizeof(unsigned long) );              // Send the final one back.
        radio.startListening();                                       // Now, resume listening so we catch the next packets.
        Serial.print(F("Sent response "));
        Serial.println(got_time);
     }
   }
   #endif
}
